package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.OrgUserLevel;
import com.sa.ibiz.demo.demo.service.OrgUserLevelService;
import com.sa.ibiz.demo.demo.service.dto.OrgUserLevelSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/orguserlevel")
public class OrgUserLevelResource
{
	@Autowired
	private OrgUserLevelService service;


	@PostMapping(value = "/update")
	public ResponseEntity<OrgUserLevel> update(@Validated @RequestBody OrgUserLevel data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("组织人员级别[update]操作发生错误","OrgUserLevel",data.getOrguserlevelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<OrgUserLevel> create(@Validated @RequestBody OrgUserLevel data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("组织人员级别[create]操作发生错误","OrgUserLevel",data.getOrguserlevelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<OrgUserLevel> getDraft(@Validated @RequestBody OrgUserLevel data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("组织人员级别[getDraft]操作发生错误","OrgUserLevel","");
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<OrgUserLevel> get(@Validated @PathVariable String id){
		OrgUserLevel data=new OrgUserLevel();
		data.setOrguserlevelid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("组织人员级别[get]操作发生错误","OrgUserLevel",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<OrgUserLevel> checkKey(@Validated @RequestBody OrgUserLevel data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("组织人员级别[checkKey]操作发生错误","OrgUserLevel",data.getOrguserlevelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<OrgUserLevel> remove(@Validated @RequestBody OrgUserLevel data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("组织人员级别[remove]操作发生错误","OrgUserLevel",data.getOrguserlevelid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<OrgUserLevel>> searchDefaultPage(@Validated @RequestBody OrgUserLevelSearchFilter filter){
		Page<OrgUserLevel> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<OrgUserLevel>> listDefault(@Validated @RequestBody OrgUserLevelSearchFilter filter){
		List<OrgUserLevel> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
